# Copyright 2004-2006, Todd Burch - Burchwood USA   http://www.burchwoodusa.com 

=begin
Smustard.com(tm) Ruby Script End User License Agreement

This is a License Agreement is between you and Smustard.com.

If you download, acquire or purchase a Ruby Script or any freeware or any other product (collectively "Scripts") from Smustard.com, then you hereby accept and agree to all of the following terms and conditions:

Smustard.com, through its agreements with individual script authors, hereby grants you a permanent, worldwide, non-exclusive, non-transferable, non-sublicensable use license with respect to its rights in the Scripts.

If you are an individual, then you may copy the Scripts onto any computer you own at any location.

If you are an entity, then you may not copy the Scripts onto any other computer unless you purchase a separate license for each computer and you must have a separate license for the use of the Script on each computer.

You may not alter, publish, market, distribute, give, transfer, sell or sublicense the Scripts or any part of the Scripts.

This License Agreement is governed by the laws of the State of Texas and the United States of America.

You agree to submit to the jurisdiction of the Courts in Houston, Harris County, Texas, United States of America, to resolve any dispute, of any kind whatsoever, arising out of, involving or relating to this License Agreement.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

This software has not been endorsed or sanctioned by Google.  Any comments, concerns or issues about this software 
or the affects of this software should be not directed to Google, but to Smustard.com.  
=end

# Name :          centerpoint.rb 1.2
# Description :   Add a construction point to the center of a selected entity or group.
# Author :        Todd Burch   http://www.burchwoodusa.com 
# Usage :         1. Select the group, component or edge or face, etc.  If multiple entities are selected, 
#                    only the first item will be acted upon.  
#                 2. Run "Set Center Point" 
# Date :          03.Dec.2004
# Type :          Tool
# History:        1.0 (03.Dec.2004) - first version
#                 1.1 (12.May.2006) - Add construction point to the active entities
#                 1.2 (21.Jul.2006) - Find the CenterPoint of the Whole Selection instead of just the 1st entity.
#
#                                  
#-----------------------------------------------------------------------------
require 'sketchup.rb'

def addCenterPoint 
  bb = Geom::BoundingBox.new ;   # Outter Shell 
  Sketchup.active_model.selection.each {|e| bb.add(e.bounds) ; } 
  Sketchup.active_model.active_entities.add_cpoint(bb.center) 
  end 

#=============================================================================

if( not file_loaded?("centerpoint.rb") )
    UI.menu("Plugins").add_item("Set Center Point") { addCenterPoint }
end
#-----------------------------------------------------------------------------
file_loaded("centerpoint.rb")

